/*   MR -- A colorful and powerful mailreader
     Copyright (C) 1997 Przemek Borys

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

     Przemek Borys can be contacted on pborys@p-soft.silesia.linux.org.pl
     (home machine), or pborys@rhea.ids.pl, or 2:484/17.25 at FidoNet.
*/
#ifndef _TLIST_H
#define _TLIST_H
#include "TWindow.h"
#include "colors.h"
#include "keyboard.h"
#include "misc.h"

class TList : public TWindow
	{
	pchar *items;  
	char *hlpfile;
	long count;
	long pos;
	int p;
	int textcolor,selectedcolor,barcolor;
	public:
	int escape;
	int space;
	void ShowWindow();      
	void virtual Keyboard();      
	void virtual KeyboardInternal(int a);
	
	TList(pchar *i, long n, int x,int y,int x1,int y1, int defaultv=0, int textcolr=A_REVERSE,int selectedcolr=A_NORMAL,int barcolr=A_REVERSE): 
	items(i), count(n),
	TWindow(x,y,x1,y1," List "),
	pos(0),p(0),escape(0),
	textcolor(textcolr),
	selectedcolor(selectedcolr),
	barcolor(barcolr),
	hlpfile("list.hlp"),
	space(0)
		{
		logfile("TList::TList"); 
		if(defaultv<=MaxHeight()) p=defaultv;
		else {pos=long(defaultv/MaxHeight())*MaxHeight(); 
			p=defaultv-pos;}
		}
	int GetElement() { return pos+p; }
	int CheckEscape() { return escape; }
	int CheckSpace() { return space; }
	void ResetSpace() {space=0;}
	};
#endif                            
