.TH MR 1 "November 1997"
.SH NAME
.B mr 
\- color and user-friendly mailreader
.SH SYNOPSIS
.B mr [
.I \-l
.B ]
.SH PARAMETERS
.I \-l
\- Turns on logging \- don't use it, if you're not about to debug the program
and modify the source. When turned on, every function, when called writes
about it to the logfile, called
.I logfile
, which is stored in the current work directory.
.SH DESCRIPTION
.B mr
is a 
.I mime 
and 
.I rfc822 
compatible mailreader. It can be used to read incoming
mail, or mailing lists. 
.B mr
is easy to use - it has 
.I menu
, 
.I status line
, 
.I on-line help
\.
It allows you to easy compose messages, supports
a kind of threading (using 
.I subjects
, not 
.I message-id
, since some listprocs cut them down). 
.B mr 
allows you to create a nice signature, and templates, which can be added 
on the beginning of the message, i.e. 
.P
.B Greetings, <receipentname>
.P
.B mr
can 
.I search 
your mailfolders for specified expressions, append your sent
messages to current mailbox, or any other, you wish. It has also 
.I lastread
pointers, which allow you to read messages starting from the moment, you
finished last time.
.P
Let's go with the desctiprion now. 
.P
When you start the program first time, it
asks you, whether you want to create a basic config file, or not. 
.P
.B mr
can't work without a config file, which defines among the others the
folders, you have. Just say "yes" to the program.

.P
When you start the program, and the config file exists, you'll see a list
of available folders. Actually it will be probably only one folder:
.P
.B My incoming mail
.P
Choose it, by pressing enter. Now, if there were some messages, you can
browse them, reply, and many other things. All options are available from
menu, which is accessable by pressing 
.I F10
\. 
If your terminal doesn't support function keys, you can simulate such key
by pressing 
.I ESC+keynumber. 
In menu, there are written shortcuts for every
available option, so I'll not write about it here, since it's clear enough,
when you look at the menu option, and at the status line description.
But anyway, I'll write a bit about composing message.
.P
.br 
.B Composing message.
.P
When you send a message, (by pressing either 
.I INS
, or 
.I i 
, 
.I c
, or 
.I q
, or 
.I f
),
you're asked about some things by the header. These are:
.P
.B To: 
\- you put here the address of the person, you're writting to. It's an
required field.
.P
.B Cc: 
\- here you put the address of a person, you want to have this msg
copied. It's an optional field.
.P
.B Bcc: 
\- same as above, but it's a 'Blind Carbon Copy' - the person, who gets
mail doesn't see it. It's an optional field.
.P
.B Subject: 
\- The subject of your message. An optional field.
.P
.B Attach: 
\- This is rather not a field, but an interface for sending file
attachments. When you get on this field, you'll see two lists - 
one with the files on your disk, and second with the files, you've
selected to send. You switch between them by pressing [tab] key.
You select a file by pressing space, move through directories
using [enter], and delete choosen files by pressing [del] key.
After you've choosen your files, you press the OK button. 
.P
.B Fcc:
\- This is a file, where a copy of your message will be stored. By default
this is the name of currently viewed folder.
.P
After you've finished editing header you go to the "subject" field of header, 
where you push the enter key. Then you start to edit the message body. You
can abort this by pressing [esc] key. When you edit the message, all
available options are listed on the status line (as ussualy ;\-). You can
abort editing, by pressing [esc].

.SH FILES
There is a set of files, which are used by 
.B mr
\.
These are 
.I *.hlp 
files, located in 
.I HELPDIR
, which provide on-line help,
.I about.mr
which keeps some information about this program,
.I charset files
, which are located in the 
.I CHARSETPATH
, and are optional,
.I mr.1
in the 
.I MANDIR
, which provides this manual page.
There are also optional template files in
.I ~/.mr/*.tpl
, but we'll discuss them later.
.B mr
uses a config file, wich is located in
.I ~/.mr/mr.rc
.P
Some administrators may want to set some global config sets, such as for
example local charset. They can use for this purpose another, "global" config
file,
.I /usr/local/etc/mr.rc
(the path can be different, but this is the default).
.P
There is an utility to this file, which calls 
.B updatemrrc
, which adds to the
.I mr.rc
file, mail folders, which exists in current directory.
.P
Here is the specification of 
.I mr.rc
:
.P
Mailfolder definition begins by writing this word:
.P
.B folder 
"
.I name of the folder
"
.P
This specifies the name, which will appear to the user, when browsing
mailfolders. Second important thing is to define path to this folder. 
So in next line you type:
.P
.B path 
"
.I /path/to/the/folder
"
.P
Note, that my program does not recognize shortcuts like '~' for homedir, 
and others (but it will be probably supported in next versions)
.P
That is. We've already defined our first folder. Now you may want to
define another folder. To do this, type in the next line 
.P
.B folder 
"
.I name of the next folder
"
.P
.B  path 
"
.I /path/to/the/next/folder
"
.P
As you see, folder definition begins by word 
.I folder
, and ends at the
begining of the next folder definition (that is there, where the next word
.I folder 
is being found).
.P
And now the goodies ;-) : except of the 
.I path 
option, folder definition
supports fields like
.P
.B defaultto 
"
.I Default receipent's address for this folder
"
.P
.B defaultcc 
"
.I Default carbon copy for this folder
"
.P
.B defaultbcc 
"
.I Default blind carbon copy for this folder
"
.P
.B replyto 
"
.I The address, where replies will be sent back to you
"
.P
.B charset 
"
.I charset
"
.P
.B AlternateEditor
"
.I Alternative external editor
"
.P
.B ForwardBanner
"
.I A banner for forwarded msgs
"
.P
.B Graph_Warez
.I yes/no
.P 
.B FileImportBanner
"
.I Banner for a text imported from a file
"
.P
Any of those options may appear in the folder definition. They don't have to
appear all \- if any of those definitions is not specified, programm assumes, 
that you don't want to use this feature. 
.P
Now I'll describe a bit more preciselly what do those fields define:
.P
.B DefaultTo
\- defines the 
.I default receipent 
in the folder for new messages. It 
sets a default username, when you write new message. It may be usefull
in mailing lists, where all new messages are to be addressed to the listserver.
.P
.B DefaultCc
\- defines the 
.I default carbon copy
\. 
Carbon copy allows you to send
the same message to different addresses.
.P
.B DefaultBcc 
\- same as above, but does not show the addreses, the message
was sent to to the receipent.
.P
.B ReplyTo 
\- defines the address, 
.I you want to receive replies 
of your messages. This is mainly used then, when you're writting from different
addres than the one you want receive replies to.
.P
.B Charset 
\- Specifies the 
.I character 
set of your country. The default is
.I US-ASCII
, but for many countries that's not enough, and, for example Europe
uses charsets like 
.I ISO\-8859\-2
, 
.I ISO\-8859\-1
, and so on, until 
.I ISO\-8859\-6 
(that is as far as I remember). 
.I Poland 
for example uses 
.I ISO\-8859\-2.
.P
.B AlternateEditor 
\- Specifies an alternate 
.I external editor
, instead of the internal one.
.P
.B ForwardBanner 
\- Specifies the banner, which will be added on the beginning
of the forwarded text message. It's independent of what is in the
forward.tpl file (about which you'll learn more later). The default value of
this field is 
"
.I \-\-\-\-\-Forwarded message\-\-\-\-\-
"
.P
.B Graph_Warez 
\- specifies, if you want or not to see some esthetical details
on the screen. They may slow down the program under some dial'up
terminals... But the default is 
.I yes
\.
.P
.B FileImportBanner 
\- the banner, which will appear, when you import a text
file to your message under internal editor. The default is 
"
.I \-\-\- cut \-\-\-
"
\.
.P
One more thing. When using quotes ,, " '' in the field's value, you
must preceede them with a backslash, that is ,, \\" ''. It is so, so the
program could differ the quote which is ending the field's value from a quote,
which is a part of this value.
One more thing: comments are assumed to be preceeded with '#' char, and they
contionue to the end of line.

And now an example of the file mr.rc:

.B \-\-\-\-\-\-\-\-\-\-\-\-\-\-\-
.br
###########################
.br
# Simple MR's config file #
.br
###########################
.br
.br
charset "ISO\-8859\-2"
.br
AlternateEditor "vi"
.br
ImportFileBoundary "**** cut it down! ****"
.br
ForwardBanner "\-\-\-\-\-\-This is a forwarded message\-\-\-\-\-\-"
.br
Graph_Warez "yes"
.br
.br
folder "Root's mail"
.br
  path "/var/spool/mail/root"
.br
  replyto "\\"Przemek Borys\\" pborys@rhea.ids.pl" #here you have an eg. for \\"
.br
folder "Przemek's mail"
.br
  path "/var/spool/mail/pborys"
.br
  defaultto "root@localhost"
.br
.B \-\-\-\-\-\-\-\-\-\-\-\-\-\-\-
.P
.B Creating templates.
.P
This program provides a set of templates. They are covered in files
.P
.I ~/.mr/new.tpl
.P
.I ~/.mr/reply.tpl
.P
.I ~/.mr/comment.tpl
.P
.I ~/.mr/forward.tpl
.P
.I ~/.mr/signature.tpl
.P
The first one defines template for new message, the second for replies, the
next for comments, the next for forwarded messages and the last defines the 
signature.
.P
These are the files, which are appended at the beginning of your messages,
and the signature is appended at end of them.
.P
When writting template files, you can use the following macros:
.P
.B @ff 
\- From First Name \- the first name of the sender of the msg 
you reply/comment to
.P
.B @fl 
\- From Last Name \- the last name of the sender of the msg, you
reply/comment to
.P
.B @tf 
\- To First Name \- the first name of the receipent of the msg you 
reply/comment to
.P
.B @tl 
\- To Last Name \- the last name of the receipent of the msg you 
reply/comment to
.P
.B @fa 
\- similar to fn, but gives the e\-mail address of the sender
.P
.B
@ta 
\- stands for the e\-mail address of the receipent
.P
.B @s 
\- stands for subject of the message you reply/comment to
.P
.B @d? 
\- stands for the date of the msg you reply/comment to. There are few
types of this macro:
.P
.I   @dy 
\- the year
.P
.I   @dm 
\- the month
.P
.I   @dd 
\- the day
.P
.I   @dw 
\- the day of week
.P
.I   @dh 
\- the hour
.P
.I   @dn 
\- the miNute
.P
.I   @ds 
\- the second 
.P
.B @@ 
\- prints the '@' sign
.P
You can edit templates from the program directly \- use the option from the
"Options" submenu.
.P
examples for templates:

.br 
.B \-\-\-
.I new.tpl
.B \-\-\-
.br 
Hello
.br
.br 
.B \-\-\-\-\-\-\-\-\-\-\-\-\-\-\-
.br 
Warning! For now new.tpl does not support macros :-( (it'll change soon)
.P
.br 
.B \-\-
.I reply.tpl
.B \-\-
.br 
Hello, @fn
.br 
@d @fn wrote to @tn
.P
.br 
.B \-\-\-\-\-\-\-\-\-\-\-\-\-\-\-
.br 
.B \-
.I comment.tpl
.B \-
.br 
Hello, @tn
.br 
@d @fn wrote to @tn
.P
.br 
.B \-\-\-\-\-\-\-\-\-\-\-\-\-\-\-
.br 
.B \-
.I forward.tpl
.B \-
.br 
Hello!
.br 
**********************************************
.br
* Forwarded message
.br
* Original author: @fn 
.br
* Original receipent: @tn
.br
**********************************************
.br
.br 
.B \-\-\-\-\-\-\-\-\-\-\-\-\-\-\-
.br 
.I signature.tpl
.br 
See ya
.br 
Przemek <pborys@@rhea.ids.pl>
.br 
.B \-\-\-\-\-\-\-\-\-\-\-\-\-\-\-

.P
.B Charset translation tables.
MR supports translation tables. You create them in the directory specified
by the variable 
.B CHARSETPATH 
of 
.I Makefile
\. Their name should correspond to the
name of an charset, you want to translate. I.e. a charset for ISO\-8859\-2
will be put in a file of name ISO\-8859\-2, here's an example:

.br 
.B \-
.I SomeCharset
.B \-
.br 
a q
.br 
b w
.br 
c e
.br 
d r
.br 
e t
.br 
f y
.br 
g u
.br 
h i
.br 
i o
.br 
j p
.br 
k a
.br 
l s
.br 
m d
.br 
n f
.br 
o g
.br 
p h
.br 
r j
.br 
s k
.br
.B \-\-\-\-\-\-\-\-\-\-\-\-\-
.P
This is an example translation - it does nothing reasonable. It translates
i.e. 
.I s
to
.I k
,
.I o
to 
.I g
, etc. Translation tables are of the format:
.br 
.B f<space>t<cr>
.br 
.B f<space>t<cr>
.br 
.B ...
.P
where f is the character, which is about to be converted, and t is a value, to
which it's going to be set. <space> is a space character, which you can get
by pressing the long button on your keyboard ;\-), and <cr> is a newline
sign, you get it by pressing Enter ;\-).

.B Changing default colors.
You may not like my default colors. Well... probably you have a bad taste,
but I gave an interface to modify colors. Get into the menu (by pressing
F10), and go to the <Options>, and choose there the option for changing
colors. After changing colors, write them to HDD (there is an option in the
<Options> submenu).

.SH AUTHOR
Przemek Borys, 
.I pborys@p-soft.silesia.linux.org.pl 
(home), 
.I pborys@rhea.ids.pl
,or
.I 2:484/17.25
at FidoNet

.SH BUGS
This is still only a test version of this program. There is probably a lot
of bugs here, but on my home machine I can work normally. The most of errors
are segmentation faults - here I count on you - fellows programmers - if you
can, please debug the segmentation fault, which caused by you, since I'm
unable to do it all.
